Index: trunk/VUT/GtpVisibilityPreprocessor/scripts/default.env
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/scripts/default.env	(revision 415)
+++ trunk/VUT/GtpVisibilityPreprocessor/scripts/default.env	(revision 416)
@@ -133,5 +133,5 @@
 	#splitPlaneStrategy 130
 	
-	splitPlaneStrategy 8
+	splitPlaneStrategy 12
 	
 	maxPolyCandidates 50
Index: trunk/VUT/GtpVisibilityPreprocessor/src/RenderSimulator.cpp
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/RenderSimulator.cpp	(revision 414)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/RenderSimulator.cpp	(revision 416)
@@ -78,5 +78,5 @@
 		// compute render time of PVS times probability that view point is in view cell
 		float vcCost = pInVc * RenderPvs(*(*it), mObjRenderCost);
-		
+		Debug << "p: " << pInVc << " rendercost: " << RenderPvs(*(*it), mObjRenderCost) << endl;
 		renderTime += vcCost;
 
@@ -99,4 +99,7 @@
 	renderTime /= pInVcTotal;
 	loadPvsOverhead /= pCrossVcTotal;
+
+	Debug << "bsp RT: " << renderTime << endl;
+	Debug << "bsp pvsOverhead: " << loadPvsOverhead << endl;
 
 	mStat.avgRtWithoutOverhead = renderTime;
Index: trunk/VUT/GtpVisibilityPreprocessor/src/Preprocessor.cpp
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/Preprocessor.cpp	(revision 411)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/Preprocessor.cpp	(revision 416)
@@ -92,8 +92,19 @@
 
 	Debug << "render simulator using render cost=" << objRenderCost << ", vc overhead=" << vcOverhead << ", move speed=" << moveSpeed << endl;
-	if (ViewCell::sHierarchy = ViewCell::BSP)
+	if (ViewCell::sHierarchy == ViewCell::BSP)
+	{
 		mRenderSimulator = new BspViewCellRenderSimulator(objRenderCost, vcOverhead, moveSpeed, mBspTree);
-	else // KD view cells
+		Debug << "creating bsp render simulator" << endl;
+	}
+	else if (ViewCell::sHierarchy == ViewCell::KD)// KD view cells
+	{
 		mRenderSimulator = new KdViewCellRenderSimulator(objRenderCost, vcOverhead, moveSpeed, mKdTree);
+		Debug << "creating kd render simulator" << endl;
+	}
+	else
+	{
+		Debug << "not implemented yet" << endl;
+		return NULL;
+	}
 
 	return mRenderSimulator;
Index: trunk/VUT/GtpVisibilityPreprocessor/src/SamplingPreprocessor.cpp
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/SamplingPreprocessor.cpp	(revision 414)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/SamplingPreprocessor.cpp	(revision 416)
@@ -548,13 +548,16 @@
 		cout << "#totalKdPvsSize=" << mKdTree->CollectLeafPvs() << endl;
   
+	//-- render simulation
+	cout << "\nevaluating bsp view cells render time before merge ... ";
+	GetRenderSimulator()->SimulateRendering();
+	
+	cout << " finished" << endl;
+
+	cout << GetRenderSimulator()->mStat << endl;
+	Debug << GetRenderSimulator()->mStat << endl;
+
+
 	if (mBspTree)
 	{
-		//-- render simulation
-		cout << "\nevaluating bsp view cells render time before merge ... ";
-		GetRenderSimulator()->SimulateRendering();
-		
-		cout << "avg render time: " << 	GetRenderSimulator()->mStat << endl;
-		Debug << "avg render time: " << GetRenderSimulator()->mStat << endl;
-
 		//-- post processing of bsp view cells
         int vcSize = 0;
@@ -599,7 +602,8 @@
 			
 		GetRenderSimulator()->SimulateRendering();
-
-		cout << "render time: " << GetRenderSimulator()->mStat << endl;
-		Debug << "render time: " << GetRenderSimulator()->mStat << endl;
+		cout << " finished" << endl;
+
+		cout << GetRenderSimulator()->mStat << endl;
+		Debug << GetRenderSimulator()->mStat << endl;
 
 		if (1) // export view cells
@@ -660,13 +664,4 @@
 	//-- several visualizations and statistics
 	if (1) {
-	
-	if (ViewCell::sHierarchy == ViewCell::KD)
-	{
-		cout << "\nevaluating kd view cells render time ... ";
-		Real rt = GetRenderSimulator()->SimulateRendering();
-		
-		cout << "avg render time: " << rt * 1e-3 << endl;
-		Debug << "avg render time: " << rt * 1e-3 << endl;
-	}
 
    for (int k=0; k < pvsOut; k++) {