Index: trunk/VUT/GtpVisibilityPreprocessor/src/Makefile
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/Makefile	(revision 401)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/Makefile	(revision 427)
@@ -1,5 +1,5 @@
 #############################################################################
 # Makefile for building: preprocessor
-# Generated by qmake (1.07a) (Qt 3.3.2) on: Wed Nov 09 22:44:25 2005
+# Generated by qmake (1.07a) (Qt 3.3.2) on: Tue Nov 22 12:10:40 2005
 # Project:  preprocessor.pro
 # Template: app
@@ -74,5 +74,8 @@
 		VssRay.cpp \
 		VssTree.cpp \
-		VssPreprocessor.cpp
+		VssPreprocessor.cpp \
+		RenderSimulator.cpp \
+		VspKdTree.cpp \
+		RayInfo.cpp
 OBJECTS =	Preprocessor.obj \
 		SamplingPreprocessor.obj \
@@ -107,5 +110,8 @@
 		VssRay.obj \
 		VssTree.obj \
-		VssPreprocessor.obj
+		VssPreprocessor.obj \
+		RenderSimulator.obj \
+		VspKdTree.obj \
+		RayInfo.obj
 FORMS =	
 UICDECLS =	
@@ -202,4 +208,7 @@
 	-$(DEL_FILE) VssTree.obj
 	-$(DEL_FILE) VssPreprocessor.obj
+	-$(DEL_FILE) RenderSimulator.obj
+	-$(DEL_FILE) VspKdTree.obj
+	-$(DEL_FILE) RayInfo.obj
 
 
@@ -220,21 +229,25 @@
 		ViewCell.h \
 		Environment.h \
-		Containers.h \
-		AxisAlignedBox3.h \
-		Rectangle3.h \
-		Matrix4x4.h \
-		Vector3.h \
-		Plane3.h \
-		common.h \
-		Material.h \
-		VssRay.h \
+		RenderSimulator.h \
+		Containers.h \
+		AxisAlignedBox3.h \
+		Rectangle3.h \
+		Matrix4x4.h \
+		Vector3.h \
+		Plane3.h \
+		common.h \
+		Material.h \
+		VssRay.h \
+		Ray.h \
 		Parser.h \
 		Mesh.h \
 		KdTree.h \
 		ViewCellBsp.h \
-		Intersectable.h \
-		Pvs.h \
-		Ray.h \
-		Polygon3.h \
+		VspKdTree.h \
+		Intersectable.h \
+		Pvs.h \
+		Polygon3.h \
+		Statistics.h \
+		RayInfo.h \
 		
 
@@ -248,4 +261,5 @@
 		Polygon3.h \
 		ViewCell.h \
+		RenderSimulator.h \
 		Containers.h \
 		AxisAlignedBox3.h \
@@ -258,10 +272,13 @@
 		Pvs.h \
 		Preprocessor.h \
-		Mesh.h \
-		ViewCellBsp.h \
-		Intersectable.h \
-		Material.h \
-		Exporter.h \
-		VssRay.h \
+		VssRay.h \
+		Mesh.h \
+		ViewCellBsp.h \
+		VspKdTree.h \
+		Intersectable.h \
+		Material.h \
+		Statistics.h \
+		RayInfo.h \
+		Exporter.h \
 		
 
@@ -274,15 +291,19 @@
 		ViewCellBsp.h \
 		ViewCell.h \
-		Intersectable.h \
-		Plane3.h \
-		Matrix4x4.h \
-		AxisAlignedBox3.h \
-		Material.h \
-		Pvs.h \
-		Rectangle3.h \
-		Vector3.h \
-		common.h \
-		Ray.h \
-		Polygon3.h \
+		VspKdTree.h \
+		Intersectable.h \
+		Plane3.h \
+		Matrix4x4.h \
+		AxisAlignedBox3.h \
+		Material.h \
+		Pvs.h \
+		Rectangle3.h \
+		Vector3.h \
+		common.h \
+		Ray.h \
+		Polygon3.h \
+		Statistics.h \
+		VssRay.h \
+		RayInfo.h \
 		
 
@@ -347,15 +368,18 @@
 		Polygon3.h \
 		VssRay.h \
-		Containers.h \
-		AxisAlignedBox3.h \
-		Rectangle3.h \
-		Matrix4x4.h \
-		Vector3.h \
-		Plane3.h \
-		Exporter.h \
-		Material.h \
-		Intersectable.h \
-		Pvs.h \
-		Ray.h \
+		VspKdTree.h \
+		Containers.h \
+		AxisAlignedBox3.h \
+		Rectangle3.h \
+		Matrix4x4.h \
+		Vector3.h \
+		Plane3.h \
+		Exporter.h \
+		Material.h \
+		Ray.h \
+		Intersectable.h \
+		Pvs.h \
+		Statistics.h \
+		RayInfo.h \
 		
 
@@ -374,4 +398,5 @@
 		VssRay.h \
 		Material.h \
+		Ray.h \
 		Pvs.h \
 		
@@ -434,20 +459,23 @@
 		SceneGraph.h \
 		Preprocessor.h \
-		Containers.h \
-		Mesh.h \
-		KdTree.h \
-		ViewCellBsp.h \
-		Intersectable.h \
-		Plane3.h \
-		Matrix4x4.h \
-		AxisAlignedBox3.h \
-		Material.h \
-		Pvs.h \
-		Rectangle3.h \
-		Vector3.h \
-		common.h \
-		Ray.h \
-		Polygon3.h \
-		VssRay.h \
+		VssRay.h \
+		Containers.h \
+		Mesh.h \
+		KdTree.h \
+		ViewCellBsp.h \
+		VspKdTree.h \
+		Intersectable.h \
+		Plane3.h \
+		Matrix4x4.h \
+		AxisAlignedBox3.h \
+		Material.h \
+		Pvs.h \
+		Rectangle3.h \
+		Vector3.h \
+		common.h \
+		Ray.h \
+		Polygon3.h \
+		Statistics.h \
+		RayInfo.h \
 		
 
@@ -476,5 +504,7 @@
 		Material.h \
 		Vector3.h \
-		common.h \
+		Ray.h \
+		common.h \
+		Matrix4x4.h \
 		
 
@@ -595,4 +625,5 @@
 		Vector3.h \
 		common.h \
+		Statistics.h \
 		
 
@@ -628,4 +659,5 @@
 		Vector3.h \
 		Containers.h \
+		Statistics.h \
 		Intersectable.h \
 		Matrix4x4.h \
@@ -644,7 +676,8 @@
 		AxisAlignedBox3.h \
 		Vector3.h \
-		common.h \
-		Rectangle3.h \
-		Matrix4x4.h \
+		Ray.h \
+		common.h \
+		Matrix4x4.h \
+		Rectangle3.h \
 		Plane3.h \
 		
@@ -660,6 +693,6 @@
 		Vector3.h \
 		common.h \
-		Rectangle3.h \
-		Matrix4x4.h \
+		Matrix4x4.h \
+		Rectangle3.h \
 		Plane3.h \
 		Pvs.h \
@@ -689,8 +722,57 @@
 		Mesh.h \
 		ViewCellBsp.h \
-		Intersectable.h \
-		Material.h \
-		Exporter.h \
-		Statistics.h \
+		VspKdTree.h \
+		Intersectable.h \
+		Material.h \
+		Statistics.h \
+		RayInfo.h \
+		Exporter.h \
+		
+
+RenderSimulator.obj: RenderSimulator.cpp  \
+		RenderSimulator.h \
+		KdTree.h \
+		ViewCellBsp.h \
+		ViewCell.h \
+		common.h \
+		Statistics.h \
+		Containers.h \
+		AxisAlignedBox3.h \
+		Ray.h \
+		Pvs.h \
+		Rectangle3.h \
+		Matrix4x4.h \
+		Vector3.h \
+		Plane3.h \
+		Mesh.h \
+		Polygon3.h \
+		Intersectable.h \
+		Material.h \
+		
+
+VspKdTree.obj: VspKdTree.cpp  \
+		VspKdTree.h \
+		Environment.h \
+		VssRay.h \
+		Intersectable.h \
+		Ray.h \
+		RayInfo.h \
+		AxisAlignedBox3.h \
+		Statistics.h \
+		Vector3.h \
+		common.h \
+		Matrix4x4.h \
+		Rectangle3.h \
+		Plane3.h \
+		Pvs.h \
+		
+
+RayInfo.obj: RayInfo.cpp  \
+		RayInfo.h \
+		Ray.h \
+		VssRay.h \
+		Matrix4x4.h \
+		Vector3.h \
+		common.h \
 		
 